# Keras Frontend

## Requirements

* python == 3.6.x
* pip >= 18

If your system uses a different Python version, we recommend using the conda environment `keras_python36.yml`. Install this using:

```bash
conda env create -f keras_python36.yml --name keras_python36
```

Activate the conda environment before installing the pip package (below) using:

```bash
conda activate keras_python36
```

**NOTE:** This step must be performed each time (for each shell process) the frontend is to be used.

## Installing the Keras Frontend Package

At the root of this project (`/projects/keras/`) install the Keras frontend pip package as:

```bash
pip3 install -e ./
```

**NOTE:** If you are using the conda environment, activate it prior to this step.

## Keras Benchmarks

Keras benchmarks can be found [here](https://gitlab.engr.illinois.edu/llvm/hpvm/-/tree/approx_hpvm_reorg_keras/hpvm/test/dnn_benchmarks/keras).

## Suppported Operations

List of supported operations and limitations detailed in https://gitlab.engr.illinois.edu/llvm/hpvm/-/blob/approx_hpvm_reorg_keras/hpvm/projects/keras/docs/Support.md
